Redmine - Defect #24030

When SVN or Git repository has a commit comment include an emoji (4 bytes charactor), error

occurs
2016-10-10 05:47 - Jiamin Wang

Status: Closed Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: SCM Estimated time: 0.00 hour
Target version:

Resolution: Invalid Affected version: 3.1.2
Description

| already set the MySQL and all databases' charset to utb8mb4

the error is in fetch_changeset method, when insert the commit comment into database table

Related issues:
Related to Redmine - Feature #31921: Changes to properly support 4 byte chara... Closed

Associated revisions

Revision 19698 - 2020-04-14 10:20 - Toshi MARUYAMA

scm: git: add new test repository which has UTF-8 Emoji committer and comments (#24030)

Revision 19699 - 2020-04-14 10:20 - Toshi MARUYAMA
scm: git: add test of UTF-8 Emoji committer and comments (#24030)

Revision 19700 - 2020-04-14 10:47 - Toshi MARUYAMA

fix source indent of previous commit (#24030)

Revision 19701 - 2020-04-14 14:04 - Toshi MARUYAMA

scm: git: replace test repository text file content meaningfully (#24030)

Revision 19706 - 2020-04-18 06:59 - Go MAEDA
Fix a RuboCop offense Style/ColonMethodCall due to r19699 (#24030).

History

#1 - 2016-10-10 05:59 - Jiamin Wang

error occurs in save_revision method in /app/models/git.rb or /app/models/subversion.rb

#2 - 2016-10-10 09:02 - Toshi MARUYAMA
- Category changed from Database to SCM

#3 - 2019-07-31 09:46 - Tobias Fischer

This is still an issue in Redmine 3.4.11

Environment:
Redmine version 3.4.11.stable.18254
Ruby version 2.2.1-p85 (2015-02-26) [x86_64-1linux]
Rails version 4.2.11.1
Environment production
Database adapter Mysgl2
SCM:
Subversion 1.6.17
Git 1.7.9.5
Filesystem

Error message in log:
Started GET "/projects/PROJECT/repository/REPO_ID" for 37.24.44.210 at 2019-07-31 09:43:30 +0200
Processing by RepositoriesController#show as HTML

Parameters: {"id"=>"PROJECT", "repository_id"=>"REPO_ID"}

Current user: USERNAME (id=5)
Completed 500 Internal Server Error in 145ms (ActiveRecord: 13.2ms)

ActiveRecord::StatementInvalid (Mysqgl2::Error: Incorrect string value: '\xFO\x9F\xA4\xA6' for column 'comments
' at row 1l: INSERT INTO ‘changesets’ ( repository_id', ‘revision', “scmid’, ‘committer’, “commit_date’, "~ commi
tted_on’, ‘comments’, ‘user_id’') VALUES (18, 'a5814b480017f£7702d46d084dalaala7cb5d05b0"', 'a5814b480017£7702d46
d084dalaala7cb5d05b0', 'Tobias Fischer <tobias.fischer@domain.tld>', '2019-07-04', '2019-07-04 21:35:45', '[ci
] gradle file bei vorherigem Commit vergessen

#4 - 2019-07-31 09:51 - Tobias Fischer

Funny thing: Also the comment here above get's truncated at the position of the emoji in my log message. Emoijis are a big issue for Redmine!

#5 - 2019-08-17 18:30 - Marius BALTEANU
- Related to Feature #31921: Changes to properly support 4 byte characters (emoji) when database is MySQL added

#6 - 2020-04-15 18:16 - Toshi MARUYAMA
- File error.png added
- File env.png added

| have added new test repository and tests because existing test repository encoding is '[SO-8859-1".
source:trunk/test/unit/repository git_test.ro@19705#L42

On my CentOS 7 MySQL 5.5.62, utf8mb4 environment passes test.
mysql> show variables like "charact
show create table change
i:f:i-i.—##****##****##****##*** ‘]
Table: changesets
Create Table: CREATE TABLE 'changesets’
1d int(11) NOT NULL AUTO_INCREMENT,
! D51tu|J id* imt(11) NOT NULL,
ision' wvarchar( NOT MNULL,
‘committer® wvarchar ) DEFAULT NULL,

‘comments’ 1text,

‘commit _date' da DEFAULT NULL,

‘scmid’ valchal 53 DEFAULT MULL,
[ DEFAULT NULL,

epos_rev’ | ository_id", "revision'),
committed_ '

Ll"| i o

e user 1d )
JCPEHENT-114 DEFHULT CHARSET=utf&mb4 ROW_FORMAT=DYNAMIC

—=

) ENGINE= DB HUTD I

1 row in set (8.00 sec)

With this change,

diff --git a/test/unit/repository_git_test.rb b/test/unit/repository_git_test.rb
https://www.redmine.org/projects/redmine/repository/svn/revisions/19705/entry/trunk/test/unit/repository_git_test.rb#L42

—-—— a/test/unit/repository_git_test.rb
+++ b/test/unit/repository_git_test.rb

@@ -592,7 +592,8 Q@ class RepositoryGitTest < ActiveSupport:

end

if File.directory? (REPOSITORY_UTF8_PATH) &&
= ! (Redmine: :Database: :mysqgl? && !is_mysgl_utf8mb4)
+ # ! (Redmine: :Database::mysgl? && !is_mysgl_utf8mb4)
+ true
def test_utf8_emoji
repo = Repository::Git.create(
:project => (@project,

NOT utf8mb4 environment causes error.

bin/rails test test/unit/repository_git_test.rb:59

#7 - 2020-04-15 19:02 - Toshi MARUYAMA
- File subversion_repository.dump.gz added

- File svn.diff added

This is Subversion test repository and test code.
Same results with git.

| give up to commit because it is very risky
if Cl server is NOT utf8mb4, tests skip.

#8 - 2020-04-15 19:08 - Toshi MARUYAMA
- File mercurial.hg added

- File mercurial.png added

This is Mercurial bundle file and its results.
https://www.redmine.org/projects/redmine/wiki/Continuous_integration

root

Name Size Revision Age Author Comment
test.ixt 260 Bytes 0:acfb23e0de38 3 days U+1F603@ U+1F603@&

Latest revisions

# Date Author Comment
¢ D:acfb23e0de38 04/12/2020 11:45 PM  U+1F603& U+1F6033@

View all revisions | View revisions

Also available in: B Atom

L]

$ LANGUAGE=C hg log -1
B:actb2iep
master

tip

U+1F603 @

sun Apr 1
summary: U+TFE03 @

#9 - 2020-04-15 19:15 - Marius BALTEANU
- Priority changed from High to Normal

Toshi, what do you think if we assign this to 4.2.0? We already have a ticket there for utf8mb4 support on mysql (#32054).

#10 - 2020-04-15 19:16 - Toshi MARUYAMA
- Status changed from New to Closed

- Resolution set to Invalid

Conclusion:

No error with correct server configuration and "encoding: utf8mb4" of database.yml.
source:trunk/config/database.yml.example@19705#L.12

#11 - 2020-04-15 19:18 - Toshi MARUYAMA
Marius BALTEANU wrote:

Toshi, what do you think if we assign this to 4.2.0? We already have a ticket there for utf8mb4 support on mysq|, please see #32054.

Good idea.

#12 - 2020-04-20 04:33 - Toshi MARUYAMA
- File same-with-r19706.diff added

This is additional patch.
"use same "Redmine::Database.mysql?" as with r19706".

Files

error.png 34.2 KB 2020-04-15 Toshi MARUYAMA
env.png 49.1 KB 2020-04-15 Toshi MARUYAMA
subversion_repository.dump.gz 113 KB 2020-04-15 Toshi MARUYAMA
svn.diff 4.8 KB 2020-04-15 Toshi MARUYAMA
mercurial.hg 445 Bytes 2020-04-15 Toshi MARUYAMA
mercurial.png 36.8 KB 2020-04-15 Toshi MARUYAMA
same-with-r19706.diff 1.95 KB 2020-04-20 Toshi MARUYAMA

2025-05-02

/4


https://www.redmine.org/versions/152
https://www.redmine.org/issues/32054
https://www.redmine.org/projects/redmine/repository/svn/revisions/19705/entry/trunk/config/database.yml.example#L12
https://www.redmine.org/versions/152
https://www.redmine.org/issues/32054
https://www.redmine.org/projects/redmine/repository/svn/revisions/19706
http://www.tcpdf.org

